diff --git a/src/main/java/net/minecraft/client/gui/GuiStats.java b/src/main/java/net/minecraft/client/gui/GuiStats.java
index e171f1e5e..67b936327 100644
--- a/src/main/java/net/minecraft/client/gui/GuiStats.java
+++ b/src/main/java/net/minecraft/client/gui/GuiStats.java
@@ -3,35 +3,41 @@ package net.minecraft.client.gui;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.achievement.stat.*;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.item.Item;
-import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.Lighting;
-import net.minecraft.client.render.entity.ItemEntityRenderer;
 import net.minecraft.core.sound.SoundCategory;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
+import org.lwjgl.opengl.GL12;
 
 import java.util.*;
 
-public class GuiStats extends GuiScreen
-{
-    private static ItemEntityRenderer itemEntityRenderer = new ItemEntityRenderer();
-    protected GuiScreen screen;
+public class GuiStats extends GuiScreen {
+    private static final int STATS_ICON_SIZE = 18;
+    private static final int COLUMN_BUTTON_SIZE = 36;
+    private static final int COLUMN0_RIGHT = 115;
+    private static final int COLUMN1_RIGHT = 165;
+    private static final int COLUMN2_RIGHT = 215;
+
+    protected GuiScreen parent;
+    protected GuiTooltip tooltip;
     protected String title;
     private GeneralStatisticsList generalStatisticsList;
     private ItemStatisticsList itemStatisticsList;
     private BlockStatisticsList blockStatisticsList;
-    private StatsCounter statsCounter;
+    private final StatsCounter statsCounter;
     private ScrolledSelectionList selectionList;
 
-    public GuiStats(GuiScreen guiscreen, StatsCounter statfilewriter)
+    public GuiStats(GuiScreen parent, StatsCounter statsCounter)
     {
         title = I18n.getInstance().translateKey("gui.statistics.label.title");
         selectionList = null;
-        screen = guiscreen;
-        statsCounter = statfilewriter;
+        this.parent = parent;
+        this.statsCounter = statsCounter;
+        tooltip = new GuiTooltip(Minecraft.getMinecraft(this));
     }
 
     @Override
@@ -72,7 +78,7 @@ public class GuiStats extends GuiScreen
         }
         if(button.id == 0)
         {
-            mc.displayGuiScreen(screen);
+            mc.displayGuiScreen(parent);
         } else
         if(button.id == 1)
         {
@@ -96,145 +102,37 @@ public class GuiStats extends GuiScreen
         super.drawScreen(mouseX, mouseY, partialTick);
     }
 
-    private void func_27138_c(int i, int j, int k)
+    private void renderItemAsIcon(int x, int y, int itemID)
     {
-        func_27147_a(i + 1, j + 1);
-        GL11.glEnable(32826 /*GL_RESCALE_NORMAL_EXT*/);
+        renderBackgroundIcon(x + 1, y + 1);
+        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         Lighting.enableInventoryLight();
-        Item item = Item.itemsList[k];
-        ItemModelDispatcher.getInstance().getDispatch(item).renderItemIntoGui(Tessellator.instance, fontRenderer, mc.renderEngine, item.getDefaultStack(), i + 2, j + 2, 1F);
+        Item item = Item.itemsList[itemID];
+        ItemModelDispatcher.getInstance().getDispatch(item).renderItemIntoGui(Tessellator.instance, fontRenderer, mc.renderEngine, item.getDefaultStack(), x + 2, y + 2, 1F);
         Lighting.disable();
-        GL11.glDisable(32826 /*GL_RESCALE_NORMAL_EXT*/);
-    }
-
-    private void func_27147_a(int i, int j)
-    {
-        func_27136_c(i, j, 0, 0);
-    }
-
-    private void func_27136_c(int i, int j, int k, int l)
-    {
-        int i1 = mc.renderEngine.getTexture("/assets/minecraft/textures/gui/slot.png");
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        mc.renderEngine.bindTexture(i1);
-        Tessellator tessellator = Tessellator.instance;
-        tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(i + 0, j + 18, zLevel, (float)(k + 0) * 0.0078125F, (float)(l + 18) * 0.0078125F);
-        tessellator.addVertexWithUV(i + 18, j + 18, zLevel, (float)(k + 18) * 0.0078125F, (float)(l + 18) * 0.0078125F);
-        tessellator.addVertexWithUV(i + 18, j + 0, zLevel, (float)(k + 18) * 0.0078125F, (float)(l + 0) * 0.0078125F);
-        tessellator.addVertexWithUV(i + 0, j + 0, zLevel, (float)(k + 0) * 0.0078125F, (float)(l + 0) * 0.0078125F);
-        tessellator.draw();
-    }
-
-    static Minecraft func_27141_a(GuiStats guistats)
-    {
-        return guistats.mc;
-    }
-
-    static FontRenderer func_27145_b(GuiStats guistats)
-    {
-        return guistats.fontRenderer;
-    }
-
-    public static StatsCounter func_27142_c(GuiStats guistats)
-    {
-        return guistats.statsCounter;
-    }
-
-    static FontRenderer func_27140_d(GuiStats guistats)
-    {
-        return guistats.fontRenderer;
-    }
-
-    static FontRenderer func_27146_e(GuiStats guistats)
-    {
-        return guistats.fontRenderer;
-    }
-
-    static Minecraft func_27143_f(GuiStats guistats)
-    {
-        return guistats.mc;
-    }
-
-    static void func_27128_a(GuiStats guistats, int i, int j, int k, int l)
-    {
-        guistats.func_27136_c(i, j, k, l);
-    }
-
-    static Minecraft func_27149_g(GuiStats guistats)
-    {
-        return guistats.mc;
-    }
-
-    static FontRenderer func_27133_h(GuiStats guistats)
-    {
-        return guistats.fontRenderer;
-    }
-
-    static FontRenderer func_27137_i(GuiStats guistats)
-    {
-        return guistats.fontRenderer;
-    }
-
-    static FontRenderer func_27132_j(GuiStats guistats)
-    {
-        return guistats.fontRenderer;
-    }
-
-    static FontRenderer func_27134_k(GuiStats guistats)
-    {
-        return guistats.fontRenderer;
-    }
-
-    static FontRenderer func_27139_l(GuiStats guistats)
-    {
-        return guistats.fontRenderer;
-    }
-
-    static void func_27129_a(GuiStats guistats, int i, int j, int k, int l, int i1, int j1)
-    {
-        guistats.drawGradientRect(i, j, k, l, i1, j1);
-    }
-
-    static FontRenderer func_27144_m(GuiStats guistats)
-    {
-        return guistats.fontRenderer;
-    }
-
-    static FontRenderer func_27127_n(GuiStats guistats)
-    {
-        return guistats.fontRenderer;
-    }
-
-    static void func_27135_b(GuiStats guistats, int i, int j, int k, int l, int i1, int j1)
-    {
-        guistats.drawGradientRect(i, j, k, l, i1, j1);
-    }
-
-    static FontRenderer func_27131_o(GuiStats guistats)
-    {
-        return guistats.fontRenderer;
+        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
 
-    static void func_27148_a(GuiStats guistats, int i, int j, int k)
+    private void renderBackgroundIcon(int x, int y)
     {
-        guistats.func_27138_c(i, j, k);
+        GL11.glColor4f(1f, 1f, 1f, 1f);
+        drawGuiIcon(x, y, 18, 18, TextureRegistry.getTexture("minecraft:gui/slot"));
     }
 
     abstract class StatsSelectionList extends ScrolledSelectionList
     {
-        protected int field_27268_b;
-        protected List field_27273_c;
-        protected Comparator<StatItem> field_27272_d;
-        public int field_27271_e;
-        public int field_27270_f;
+        protected int clickedColumn;
+        protected List<StatItem> statsList;
+        protected Comparator<StatItem> statsSorter;
+        public int sortingColumn;
+        public int sortingMode;
 
         protected StatsSelectionList()
         {
             super(mc, width, height, 32, height - 64, 20);
-            field_27268_b = -1;
-            field_27271_e = -1;
-            field_27270_f = 0;
+            clickedColumn = -1;
+            sortingColumn = -1;
+            sortingMode = 0;
             setRenderSelection(false);
             setRenderHeader(true, 20);
         }
@@ -261,68 +159,61 @@ public class GuiStats extends GuiScreen
         {
             if(!Mouse.isButtonDown(0))
             {
-                field_27268_b = -1;
+                clickedColumn = -1;
             }
-            if(field_27268_b == 0)
-            {
-                func_27136_c((x + 115) - 18, y + 1, 0, 0);
-            } else
-            {
-                func_27136_c((x + 115) - 18, y + 1, 0, 18);
+            if(clickedColumn == 0) {
+                drawGuiIcon((x + COLUMN0_RIGHT) - STATS_ICON_SIZE + 1, y + 2, 18, 18, TextureRegistry.getTexture("minecraft:gui/slot"));
+            } else {
+                drawGuiIcon((x + COLUMN0_RIGHT) - STATS_ICON_SIZE, y + 1, 18, 18, TextureRegistry.getTexture("minecraft:gui/slot_raised"));
             }
-            if(field_27268_b == 1)
-            {
-                func_27136_c((x + 165) - 18, y + 1, 0, 0);
-            } else
-            {
-                func_27136_c((x + 165) - 18, y + 1, 0, 18);
+            if(clickedColumn == 1) {
+                drawGuiIcon((x + COLUMN1_RIGHT) - STATS_ICON_SIZE + 1, y + 2, 18, 18, TextureRegistry.getTexture("minecraft:gui/slot"));
+            } else {
+                drawGuiIcon((x + COLUMN1_RIGHT) - STATS_ICON_SIZE, y + 1, 18, 18, TextureRegistry.getTexture("minecraft:gui/slot_raised"));
             }
-            if(field_27268_b == 2)
-            {
-                func_27136_c((x + 215) - 18, y + 1, 0, 0);
-            } else
-            {
-                func_27136_c((x + 215) - 18, y + 1, 0, 18);
+            if(clickedColumn == 2) {
+                drawGuiIcon((x + COLUMN2_RIGHT) - STATS_ICON_SIZE + 1, y + 2, 18, 18, TextureRegistry.getTexture("minecraft:gui/slot"));
+            } else {
+                drawGuiIcon((x + COLUMN2_RIGHT) - STATS_ICON_SIZE, y + 1, 18, 18, TextureRegistry.getTexture("minecraft:gui/slot_raised"));
             }
-            if(field_27271_e != -1)
+            if(sortingColumn != -1)
             {
-                char c = 'O';
-                byte byte0 = 18;
-                if(field_27271_e == 1)
+                int c = COLUMN0_RIGHT - COLUMN_BUTTON_SIZE;
+                boolean up = false;
+                if(sortingColumn == 1)
                 {
-                    c = '\201';
-                } else
-                if(field_27271_e == 2)
+                    c = COLUMN1_RIGHT - COLUMN_BUTTON_SIZE;
+                } else if(sortingColumn == 2)
                 {
-                    c = '\263';
+                    c = COLUMN2_RIGHT - COLUMN_BUTTON_SIZE;
                 }
-                if(field_27270_f == 1)
+                if(sortingMode == 1)
                 {
-                    byte0 = 36;
+                    up = true;
                 }
-                func_27136_c(x + c, y + 1, byte0, 0);
+                drawGuiIcon(x + c, y + 1, 18, 18, TextureRegistry.getTexture("minecraft:gui/arrow_" + (up ? "up" : "down")));
             }
         }
 
         @Override
         protected void clickedHeader(int x, int y)
         {
-            field_27268_b = -1;
-            if(x >= 79 && x < 115)
+            clickedColumn = -1;
+            if(x >= COLUMN0_RIGHT - COLUMN_BUTTON_SIZE && x < COLUMN0_RIGHT)
             {
-                field_27268_b = 0;
+                clickedColumn = 0;
             } else
-            if(x >= 129 && x < 165)
+            if(x >= COLUMN1_RIGHT - COLUMN_BUTTON_SIZE && x < COLUMN1_RIGHT)
             {
-                field_27268_b = 1;
+                clickedColumn = 1;
             } else
-            if(x >= 179 && x < 215)
+            if(x >= COLUMN2_RIGHT - COLUMN_BUTTON_SIZE && x < COLUMN2_RIGHT)
             {
-                field_27268_b = 2;
+                clickedColumn = 2;
             }
-            if(field_27268_b >= 0)
+            if(clickedColumn >= 0)
             {
-                func_27266_c(field_27268_b);
+                clickedColumn(clickedColumn);
                 mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
             }
         }
@@ -330,110 +221,88 @@ public class GuiStats extends GuiScreen
         @Override
         protected final int getItemCount()
         {
-            return field_27273_c.size();
+            return statsList.size();
         }
 
-        protected final StatItem func_27264_b(int i)
+        protected final StatItem getStat(int index)
         {
-            return (StatItem)field_27273_c.get(i);
+            return statsList.get(index);
         }
 
-        protected abstract String func_27263_a(int i);
+        protected abstract String getTooltipKey(int column);
 
-        protected void func_27265_a(StatItem statcrafting, int i, int j, boolean flag)
+        protected void renderStatValue(StatItem statItem, int x, int y, boolean white)
         {
-            if(statcrafting != null)
+            if(statItem != null)
             {
-                String s = statcrafting.makeString(statsCounter.readStat(statcrafting));
-                drawString(fontRenderer, s, i - fontRenderer.getStringWidth(s), j + 5, flag ? 0xffffff : 0x909090);
+                String s = statItem.getFormattedValue(statsCounter.readStat(statItem));
+                drawString(fontRenderer, s, x - fontRenderer.getStringWidth(s), y + 5, white ? 0xffffff : 0x909090);
             } else
             {
                 String s1 = "-";
-                drawString(fontRenderer, s1, i - fontRenderer.getStringWidth(s1), j + 5, flag ? 0xffffff : 0x909090);
+                drawString(fontRenderer, s1, x - fontRenderer.getStringWidth(s1), y + 5, white ? 0xffffff : 0x909090);
             }
         }
 
         @Override
         protected void renderDecorations(int x, int y)
         {
+            GL11.glEnable(GL11.GL_TEXTURE_2D);
+            GL11.glShadeModel(GL11.GL_FLAT);
+            GL11.glEnable(GL11.GL_ALPHA_TEST);
             if(y < y0 || y > y1)
             {
                 return;
             }
-            int k = getItemAtPosition(x, y);
-            int l = width / 2 - 92 - 16;
-            if(k >= 0)
-            {
-                if(x < l + 40 || x > l + 40 + 20)
-                {
+            int row = getItemAtPosition(x, y);
+            int statsListLeft = width / 2 - 92 - 16;
+            if(row >= 0) { // If in darkened middle section (stats list)
+                if(x < statsListLeft + 40 || x > statsListLeft + 40 + 20) { // Return if not hovering over item icon column
                     return;
                 }
-                StatItem statcrafting = func_27264_b(k);
-                func_27267_a(statcrafting, x, y);
+                StatItem statItem = getStat(row);
+                renderStatItemTooltip(statItem, x, y);
             } else
             {
-                String s = "";
-                if(x >= (l + 115) - 18 && x <= l + 115)
-                {
-                    s = func_27263_a(0);
-                } else
-                if(x >= (l + 165) - 18 && x <= l + 165)
-                {
-                    s = func_27263_a(1);
-                } else
-                if(x >= (l + 215) - 18 && x <= l + 215)
-                {
-                    s = func_27263_a(2);
-                } else
-                {
+                String s;
+                if(x >= (statsListLeft + COLUMN0_RIGHT) - STATS_ICON_SIZE && x <= statsListLeft + COLUMN0_RIGHT) {
+                    s = getTooltipKey(0);
+                } else if(x >= (statsListLeft + COLUMN1_RIGHT) - STATS_ICON_SIZE && x <= statsListLeft + COLUMN1_RIGHT) {
+                    s = getTooltipKey(1);
+                } else if(x >= (statsListLeft + COLUMN2_RIGHT) - STATS_ICON_SIZE && x <= statsListLeft + COLUMN2_RIGHT) {
+                    s = getTooltipKey(2);
+                } else {
                     return;
                 }
-                s = (new StringBuilder()).append("").append(I18n.getInstance().translateKey(s)).toString().trim();
-                if(s.length() > 0)
-                {
-                    int i1 = x + 12;
-                    int j1 = y - 12;
-                    int k1 = fontRenderer.getStringWidth(s);
-                    drawGradientRect(i1 - 3, j1 - 3, i1 + k1 + 3, j1 + 8 + 3, 0xc0000000, 0xc0000000);
-                    fontRenderer.drawStringWithShadow(s, i1, j1, -1);
-                }
+                s = I18n.getInstance().translateKey(s).trim();
+                tooltip.render(s, x, y, 8, -8);
             }
         }
 
-        protected void func_27267_a(StatItem statcrafting, int i, int j)
+        protected void renderStatItemTooltip(StatItem statItem, int x, int y)
         {
-            if(statcrafting == null)
-            {
+            if(statItem == null) {
                 return;
             }
-            Item item = Item.itemsList[statcrafting.getItemID()];
-            String s = (new StringBuilder()).append("").append(I18n.getInstance().translateNameKey(item.getKey())).toString().trim();
-            if(s.length() > 0)
-            {
-                int k = i + 12;
-                int l = j - 12;
-                int i1 = fontRenderer.getStringWidth(s);
-                drawGradientRect(k - 3, l - 3, k + i1 + 3, l + 8 + 3, 0xc0000000, 0xc0000000);
-                fontRenderer.drawStringWithShadow(s, k, l, -1);
-            }
+            Item item = statItem.getItem();
+            String s = I18n.getInstance().translateNameKey(item.getKey()).trim();
+            tooltip.render(s, x, y, 8, -8);
         }
 
-        protected void func_27266_c(int i)
+        protected void clickedColumn(int column)
         {
-            if(i != field_27271_e)
+            if(column != sortingColumn)
             {
-                field_27271_e = i;
-                field_27270_f = -1;
-            } else
-            if(field_27270_f == -1)
+                sortingColumn = column;
+                sortingMode = -1;
+            } else if(sortingMode == -1)
             {
-                field_27270_f = 1;
-            } else
-            {
-                field_27271_e = -1;
-                field_27270_f = 0;
+                sortingMode = 1;
+            } else {
+                sortingColumn = -1;
+                sortingMode = 0;
             }
-            Collections.sort(field_27273_c, field_27272_d);
+            statsList.sort(statsSorter);
         }
     }
 
@@ -449,7 +318,7 @@ public class GuiStats extends GuiScreen
         @Override
         protected int getItemCount()
         {
-            return StatList.statList2.size();
+            return StatList.basicStats.size();
         }
 
         @Override
@@ -478,9 +347,9 @@ public class GuiStats extends GuiScreen
         @Override
         protected void renderItem(int index, int x, int y, int height, Tessellator tessellator)
         {
-            Stat statbase = (Stat)StatList.statList2.get(index);
-            drawString(fontRenderer, statbase.getStatName(), x + 2, y + 1, index % 2 != 0 ? 0x909090 : 0xffffff);
-            String s = statbase.makeString(statsCounter.readStat(statbase));
+            Stat stat = StatList.basicStats.get(index);
+            drawString(fontRenderer, stat.getStatName(), x + 2, y + 1, index % 2 != 0 ? 0x909090 : 0xffffff);
+            String s = stat.getFormattedValue(statsCounter.readStat(stat));
             drawString(fontRenderer, s, (x + 2 + 213) - fontRenderer.getStringWidth(s), y + 1, index % 2 != 0 ? 0x909090 : 0xffffff);
         }
     }
@@ -490,72 +359,62 @@ public class GuiStats extends GuiScreen
 
         public ItemStatisticsList()
         {
-            field_27273_c = new ArrayList();
-            Iterator iterator = StatList.usedItemStatsList.iterator();
-            do
-            {
-                if(!iterator.hasNext())
-                {
-                    break;
-                }
-                StatItem statcrafting = (StatItem)iterator.next();
+            statsList = new ArrayList<>();
+            for (Stat stat : StatList.usedItemStats) {
+                StatItem statItem = (StatItem) stat;
                 boolean flag = false;
-                int i = statcrafting.getItemID();
-                if(statsCounter.readStat(statcrafting) > 0)
-                {
+                int i = statItem.getItemID();
+                Stat broken = statItem.getItem().getStat(StatList.STAT_DEPLETED);
+                Stat crafted = statItem.getItem().getStat(StatList.STAT_CRAFTED);
+                if (statsCounter.readStat(statItem) > 0) {
                     flag = true;
-                } else
-                if(StatList.breakItemStats[i] != null && statsCounter.readStat(StatList.breakItemStats[i]) > 0)
-                {
+                } else if (broken != null && statsCounter.readStat(broken) > 0) {
                     flag = true;
-                } else
-                if(StatList.craftedItemStats[i] != null && statsCounter.readStat(StatList.craftedItemStats[i]) > 0)
-                {
+                } else if (crafted != null && statsCounter.readStat(crafted) > 0) {
                     flag = true;
                 }
-                if(flag)
-                {
-                    field_27273_c.add(statcrafting);
+                if (flag) {
+                    statsList.add(statItem);
                 }
-            } while(true);
-            field_27272_d = (si1, si2) -> {
-                int i = si1.getItemID();
-                int j = si2.getItemID();
-                Stat statbase = null;
+            }
+            statsSorter = (stat1, stat2) -> {
+                int id1 = stat1.getItemID();
+                int id2 = stat2.getItemID();
                 Stat statbase1 = null;
-                if(field_27271_e == 0)
+                Stat statbase2 = null;
+                if(sortingColumn == 0)
                 {
-                    statbase = StatList.breakItemStats[i];
-                    statbase1 = StatList.breakItemStats[j];
+                    statbase1 = stat1.getItem().getStat(StatList.STAT_DEPLETED);
+                    statbase2 = stat2.getItem().getStat(StatList.STAT_DEPLETED);
                 } else
-                if(field_27271_e == 1)
+                if(sortingColumn == 1)
                 {
-                    statbase = StatList.craftedItemStats[i];
-                    statbase1 = StatList.craftedItemStats[j];
+                    statbase1 = stat1.getItem().getStat(StatList.STAT_CRAFTED);
+                    statbase2 = stat2.getItem().getStat(StatList.STAT_CRAFTED);
                 } else
-                if(field_27271_e == 2)
+                if(sortingColumn == 2)
                 {
-                    statbase = StatList.usedItemStats[i];
-                    statbase1 = StatList.usedItemStats[j];
+                    statbase1 = stat1.getItem().getStat(StatList.STAT_USED);
+                    statbase2 = stat2.getItem().getStat(StatList.STAT_USED);
                 }
-                if(statbase != null || statbase1 != null)
+                if(statbase1 != null || statbase2 != null)
                 {
-                    if(statbase == null)
+                    if(statbase1 == null)
                     {
                         return 1;
                     }
-                    if(statbase1 == null)
+                    if(statbase2 == null)
                     {
                         return -1;
                     }
-                    int k = statsCounter.readStat(statbase);
-                    int l = statsCounter.readStat(statbase1);
+                    int k = statsCounter.readStat(statbase1);
+                    int l = statsCounter.readStat(statbase2);
                     if(k != l)
                     {
-                        return (k - l) * field_27270_f;
+                        return (k - l) * sortingMode;
                     }
                 }
-                return i - j;
+                return id1 - id2;
             };
         }
 
@@ -563,48 +422,48 @@ public class GuiStats extends GuiScreen
         protected void renderHeader(int x, int y, Tessellator tessellator)
         {
             super.renderHeader(x, y, tessellator);
-            if(field_27268_b == 0)
+            if(clickedColumn == 0)
             {
-                func_27136_c(((x + 115) - 18) + 1, y + 1 + 1, 72, 18);
+                drawGuiIcon((x + COLUMN0_RIGHT) - STATS_ICON_SIZE + 1, y + 2, 18, 18, TextureRegistry.getTexture("minecraft:gui/depleted"));
             } else
             {
-                func_27136_c((x + 115) - 18, y + 1, 72, 18);
+                drawGuiIcon((x + COLUMN0_RIGHT) - STATS_ICON_SIZE, y + 1, 18, 18, TextureRegistry.getTexture("minecraft:gui/depleted"));
             }
-            if(field_27268_b == 1)
+            if(clickedColumn == 1)
             {
-                func_27136_c(((x + 165) - 18) + 1, y + 1 + 1, 18, 18);
+                drawGuiIcon((x + COLUMN1_RIGHT) - STATS_ICON_SIZE + 1, y + 2, 18, 18, TextureRegistry.getTexture("minecraft:gui/crafted"));
             } else
             {
-                func_27136_c((x + 165) - 18, y + 1, 18, 18);
+                drawGuiIcon((x + COLUMN1_RIGHT) - STATS_ICON_SIZE, y + 1, 18, 18, TextureRegistry.getTexture("minecraft:gui/crafted"));
             }
-            if(field_27268_b == 2)
+            if(clickedColumn == 2)
             {
-                func_27136_c(((x + 215) - 18) + 1, y + 1 + 1, 36, 18);
+                drawGuiIcon((x + COLUMN2_RIGHT) - STATS_ICON_SIZE + 1, y + 2, 18, 18, TextureRegistry.getTexture("minecraft:gui/used"));
             } else
             {
-                func_27136_c((x + 215) - 18, y + 1, 36, 18);
+                drawGuiIcon((x + COLUMN2_RIGHT) - STATS_ICON_SIZE, y + 1, 18, 18, TextureRegistry.getTexture("minecraft:gui/used"));
             }
         }
 
         @Override
         protected void renderItem(int index, int x, int y, int height, Tessellator tessellator)
         {
-            StatItem statcrafting = func_27264_b(index);
-            int i1 = statcrafting.getItemID();
-            func_27138_c(x + 40, y, i1);
-            func_27265_a((StatItem)StatList.breakItemStats[i1], x + 115, y, index % 2 == 0);
-            func_27265_a((StatItem)StatList.craftedItemStats[i1], x + 165, y, index % 2 == 0);
-            func_27265_a(statcrafting, x + 215, y, index % 2 == 0);
+            StatItem statItem = getStat(index);
+            int i1 = statItem.getItemID();
+            renderItemAsIcon(x + 40, y, i1);
+            renderStatValue((StatItem)statItem.getItem().getStat(StatList.STAT_DEPLETED), x + COLUMN0_RIGHT, y, index % 2 == 0);
+            renderStatValue((StatItem)statItem.getItem().getStat(StatList.STAT_CRAFTED), x + COLUMN1_RIGHT, y, index % 2 == 0);
+            renderStatValue(statItem, x + COLUMN2_RIGHT, y, index % 2 == 0);
         }
 
         @Override
-        protected String func_27263_a(int i)
+        protected String getTooltipKey(int column)
         {
-            if(i == 1)
+            if(column == 1)
             {
                 return "stat.crafted";
             }
-            if(i == 2)
+            if(column == 2)
             {
                 return "stat.used";
             } else
@@ -619,72 +478,59 @@ public class GuiStats extends GuiScreen
 
         public BlockStatisticsList()
         {
-            field_27273_c = new ArrayList();
-            Iterator iterator = StatList.statList3.iterator();
-            do
-            {
-                if(!iterator.hasNext())
-                {
-                    break;
-                }
-                StatItem statcrafting = (StatItem)iterator.next();
+            statsList = new ArrayList<>();
+            for (Stat stat : Objects.requireNonNull(Item.getStats(StatList.STAT_MINED))) {
+                StatItem statItem = (StatItem) stat;
                 boolean flag = false;
-                int i = statcrafting.getItemID();
-                if(statsCounter.readStat(statcrafting) > 0)
-                {
+
+                Stat used = statItem.getItem().getStat(StatList.STAT_USED);
+                Stat crafted = statItem.getItem().getStat(StatList.STAT_CRAFTED);
+
+                if (statsCounter.readStat(statItem) > 0) {
                     flag = true;
-                } else
-                if(StatList.usedItemStats[i] != null && statsCounter.readStat(StatList.usedItemStats[i]) > 0)
-                {
+                } else if (used != null && statsCounter.readStat(used) > 0) {
                     flag = true;
-                } else
-                if(StatList.craftedItemStats[i] != null && statsCounter.readStat(StatList.craftedItemStats[i]) > 0)
-                {
+                } else if (crafted != null && statsCounter.readStat(crafted) > 0) {
                     flag = true;
                 }
-                if(flag)
-                {
-                    field_27273_c.add(statcrafting);
+                if (flag) {
+                    statsList.add(statItem);
                 }
-            } while(true);
-            field_27272_d = (si1, si2) -> {
-                int i = si1.getItemID();
-                int j = si2.getItemID();
-                Stat statbase = null;
+            }
+            statsSorter = (stat1, stat2) -> {
+                int id1 = stat1.getItemID();
+                int id2 = stat2.getItemID();
                 Stat statbase1 = null;
-                if(field_27271_e == 2)
-                {
-                    statbase = StatList.mineBlockStatArray[i];
-                    statbase1 = StatList.mineBlockStatArray[j];
-                } else
-                if(field_27271_e == 0)
+                Stat statbase2 = null;
+                if(sortingColumn == 2)
                 {
-                    statbase = StatList.craftedItemStats[i];
-                    statbase1 = StatList.craftedItemStats[j];
-                } else
-                if(field_27271_e == 1)
-                {
-                    statbase = StatList.usedItemStats[i];
-                    statbase1 = StatList.usedItemStats[j];
+                    statbase1 = stat1.getItem().getStat(StatList.STAT_MINED);
+                    statbase2 = stat2.getItem().getStat(StatList.STAT_MINED);
+                } else if(sortingColumn == 0) {
+                    statbase1 = stat1.getItem().getStat(StatList.STAT_CRAFTED);
+                    statbase2 = stat2.getItem().getStat(StatList.STAT_CRAFTED);
+                } else if(sortingColumn == 1) {
+                    statbase1 = stat1.getItem().getStat(StatList.STAT_USED);
+                    statbase2 = stat2.getItem().getStat(StatList.STAT_USED);
                 }
-                if(statbase != null || statbase1 != null)
+                if(statbase1 != null || statbase2 != null)
                 {
-                    if(statbase == null)
+                    if(statbase1 == null)
                     {
                         return 1;
                     }
-                    if(statbase1 == null)
+                    if(statbase2 == null)
                     {
                         return -1;
                     }
-                    int k = statsCounter.readStat(statbase);
-                    int l = statsCounter.readStat(statbase1);
+                    int k = statsCounter.readStat(statbase1);
+                    int l = statsCounter.readStat(statbase2);
                     if(k != l)
                     {
-                        return (k - l) * field_27270_f;
+                        return (k - l) * sortingMode;
                     }
                 }
-                return i - j;
+                return id1 - id2;
 
             };
         }
